#!/bin/bash
set -ex

# see man flock "EXAMPLES"
[ "${FLOCKER}" != "$0" ] && exec env FLOCKER="$0" flock -enF "$0" "$0" "$@" || :

DATADIR={{ jma_gsm_datadir | quote }}
WORKDIR={{ jma_gsm_workdir | quote }}
mkdir -p "$WORKDIR" "$DATADIR"

HERE="`dirname $0`"
CONFIGGSM="$HERE/cdmGribReaderConfigGSM.xml"

FIMEX_VCROSS={{ metws_job_scripts | quote }}/util/fimex-vcross
FIMEX_VERIF={{ metws_job_scripts | quote }}/util/fimex-verif
RT={{ metws_job_scripts | quote }}/util/rounded_times

{% if (jma_gsm_minlon is not defined) or (jma_gsm_minlon < 30.0) or (jma_gsm_maxlon > 195.0) or (jma_gsm_minlat < -5.0)  %}
AREA="90.0_-90.0_0.0_359.5"
REGION=gl
{% else %}
AREA="90.0_-5.0_30.0_195.0"
REGION=ra2
{% endif %}
RES_P="0p5"
RES_D="${RES_P/p/.}"
BASEURL="https://www.wis-jma.go.jp/d/c/RJTD/GRIB/Global_Spectral_Model/Latitude_Longitude/${RES_D}_${RES_D}/$AREA"

# cleanup
AGE={{ jma_gsm_max_age_days | quote }}
find "$WORKDIR" -maxdepth 1 -type d -name "gsm_${RES_P}_????????_??" -mtime "+$AGE" -exec rm -rf \{\} \;
find "$WORKDIR" -type f -name "gsm_${RES_P}_????????_??.grbml"       -mtime "+$AGE" -exec rm -vf \{\} \;
find "$DATADIR" -type f -name "gsm_${RES_P}_????????_??.nc"          -mtime "+$AGE" -exec rm -vf \{\} \;
find "$DATADIR" -type f -name "gsm_${RES_P}_????????_??_vc.nc"       -mtime "+$AGE" -exec rm -vf \{\} \;
find "$DATADIR" -type f -name "gsm_${RES_P}_????????_??_vf.nc"       -mtime "+$AGE" -exec rm -vf \{\} \;

HOURS="0000 0003 0006 0009 0012 0015 0018 0021 0100 0103 0106 0109 0112 0115 0118 0121 0200 0203 0206 0209 0212 0215 0218 0221"
HOURS="$HOURS 0300 0303 0306 0309 0312 0315 0318 0321 0400 0403 0406 0409 0412 0415 0418 0421 0500 0503 0506 0509 0512"
HOURS="$HOURS 0518 0600 0606 0612 0618 0700 0706 0712 0718 0800 0806 0812 0818 0900 0906 0912 0918 1000 1006 1012 1018 1100"

LEVELS="1000 975 950 925 900 850 800 700 600 500 400 300 250 200 150 100 70 50 30 20 10"

get_and_index() {
    FN="$2"
    URL="$BASEURL/$1/$TODAY/$HOUR/$FN"
    DFN="$DIR/$FN"

    if test ! -r "$DFN" ; then
        wget -q -o- \
            --http-user={{ jma_gsm_user | quote }} --http-password={{ jma_gsm_pass | quote }} \
            -O "$DFN" "$URL"

        # fimex uses eccodes in a way that does not work for multi-messages; use grib_copy
        # to get rid of multi-messages
        grib_copy "$DFN" "$DFN.copy" && mv -vf "$DFN.copy" "$DFN"

        fiIndexGribs \
            --readerConfig "$CONFIGGSM" \
            -a "$GRI" \
            -i "$DFN"
    fi
}

fetch_gsm() {
    TIME="$1"
    T=`date --utc '+%Y%m%d_%H' --date "$TIME"`
    TODAY=`date --utc '+%Y%m%d' --date "$TIME"`
    HOUR=`date --utc '+%H0000' --date "$TIME"`

    GRI="$WORKDIR/gsm_${RES_P}_$T.grbml"
    DIR="$WORKDIR/gsm_${RES_P}_$T"
    mkdir -p "$DIR"

    for h in $HOURS
    do
        get_and_index "Surface_layers" "GSM_GPV_R${REGION}_Gll${RES_P}deg_Lsurf_FD${h}_grib2.bin"

        for l in $LEVELS
        do
            get_and_index "${l}hPa" "GSM_GPV_R${REGION}_Gll${RES_P}deg_Lp${l}_FD${h}_grib2.bin"
        done
    done
}

# fetch grib files and create grbml index file
INT={{ jma_gsm_reftime_interval | quote }}
DLY={{ jma_gsm_reftime_delay | quote }}
CNT={{ jma_gsm_reftime_count | quote }}
for TIME in `"$RT" --interval "$INT" --delay "$DLY" --count "$CNT"` ; do
    if fetch_gsm \
           "$TIME"
    then
        :
    else
        T=`date --utc '+%Y%m%d_%H' --date "$TIME"`
        rm -vf "$WORKDIR/gsm_${RES_P}_${T}.grbml"
        rm -rf "$WORKDIR/gsm_${RES_P}_${T}"
    fi
done

# create netCDF-files
for i in "$WORKDIR/gsm_${RES_P}"_????????_??.grbml; do
    NCFILE="${i/.grbml/.nc}"
    NCFILE="${DATADIR}/`basename $NCFILE`"
    if test ! -f "$NCFILE" -o "$CONFIGGSM" -nt "$NCFILE" -o "$i" -nt "$NCFILE" ; then
        echo "creating $NCFILE"
        rm -vf "$NCFILE" "${NCFILE/.nc/_vc.nc}"
        fimex \
            --input.file="$i" \
            --input.type=grbml \
            --input.config="$CONFIGGSM" \
{% if jma_gsm_minlon is defined and jma_gsm_minlon %}
            --extract.reduceToBoundingBox.south {{ jma_gsm_minlat | quote }} \
            --extract.reduceToBoundingBox.north {{ jma_gsm_maxlat | quote }} \
            --extract.reduceToBoundingBox.west  {{ jma_gsm_minlon | quote }} \
            --extract.reduceToBoundingBox.east  {{ jma_gsm_maxlon | quote }} \
{% endif %}
            --output.file="$NCFILE" \
            --output.type=nc4
    else
        echo "$NCFILE exists, not creating new one"
    fi

    "$FIMEX_VCROSS" "$NCFILE"
    "$FIMEX_VERIF"  "$NCFILE"
done

MP={{ metws_job_scripts | quote }}/util/make_time_size_prom_file
if test -x "$MP" ; then
    FILES=()
    VCFILES=()
    for TIME in `"$RT" --interval "$INT" --delay "$DLY" --count "$CNT"` ; do
        T=`date --utc '+%Y%m%d_%H' --date "$TIME"`
        FILES+=("${DATADIR}/gsm_${RES_P}_${T}.nc")
        VCFILES+=("${DATADIR}/gsm_0p5_${T}_vc.nc")
    done

    "$MP" "devcoop_jma_gsm_${RES_P}_latest" "latest GSM ${RES_D} NetCDF file" "${FILES[@]}"
    "$MP" "devcoop_jma_gsm_${RES_P}_vc_latest" "latest GSM 0p5 vcross NetCDF file" "${VCFILES[@]}"
fi

exit 0
